var path = require("path");
var fileAndFolderUtils = require('../file-and-folder-utils');
var consoleFileLogger = require("../sl-logger.js").consoleFileLogger;
var utils = require('../utils');
var SlJsInfra = require('sl-js-infra').SlJsInfra;
var CiaEnvVars = SlJsInfra.SlEnvVars.CIA;

var RELATIVE_PATH_SIGN = "../";

var SourceFileResolver ={};

SourceFileResolver.isResolved = false;
SourceFileResolver.sourceRoot = "";


function extractSourceRoot(givenSource, sourcePath, log) {
    var normalizedGiven = path.normalize(givenSource);
    var normalizedSource = path.normalize(sourcePath);
    normalizedGiven = utils.adjustPathSlashes(normalizedGiven);
    normalizedSource = utils.adjustPathSlashes(normalizedSource);
    var trimmed = normalizedGiven.substring(normalizedGiven.lastIndexOf(RELATIVE_PATH_SIGN)+3);
    var sourceRoot = normalizedSource.replace(trimmed, "");
    log.info("found source in path: '%s'", sourceRoot);
    SourceFileResolver.sourceRoot = sourceRoot;
    SourceFileResolver.isResolved = true;
    return SourceFileResolver.sourceRoot;
}

SourceFileResolver.resolveSourceRoot = function (givenSource, mapFileDir, logger) {
    var log = logger ? logger.child({
        methodName: "resolveSourc   eRoot"
    }) : consoleFileLogger("resolveSourceRoot");
    if(givenSource.indexOf("node_modules") > -1){
        return mapFileDir;
    }
    if (SourceFileResolver.isResolved) {
        return SourceFileResolver.sourceRoot;
    }
    if (CiaEnvVars.getSourceRoot() != null) {
        SourceFileResolver.sourceRoot = CiaEnvVars.getSourceRoot();
        SourceFileResolver.isResolved = true;
        return SourceFileResolver.sourceRoot;
    }
    var sourcePath = fileAndFolderUtils.findFileRecursively(givenSource, mapFileDir, true, logger);
    if(sourcePath){
        return extractSourceRoot(givenSource, sourcePath, log);
    }
    return mapFileDir;


};

module.exports = SourceFileResolver;
